<?php
/**
 *
 * @category        modules
 * @package         404 page redirect
 * @author          Ruud Eisinga / Dev4me
 * @link			http://www.dev4me.nl/modules-snippets/opensource/404/
 * @license         http://www.gnu.org/licenses/gpl.html
 * @platform        WebsiteBaker 2.8.x
 * @requirements    PHP 5.6 and higher
 * @version         1.6.0
 * @lastmodified    June 17, 2024
 *
 *
 */

// prevent this file from being accessed directly
if(!defined('WB_PATH')) die(header('Location: index.php'));  
global $MOD_404;
require_once(WB_PATH.'/modules/mod404/languages/EN.php');
if(file_exists(WB_PATH.'/modules/mod404/languages/'.LANGUAGE.'.php')) {
	require_once(WB_PATH.'/modules/mod404/languages/'.LANGUAGE.'.php');
}

require_once (WB_PATH.'/modules/mod404/functions.php');



$url = $_SERVER["SERVER_NAME"].$_SERVER["REQUEST_URI"];
$wrong = array();
$page_link = '';

//$result = $database->query("SELECT * FROM ".TABLE_PREFIX."mod_404 ORDER BY `404_id`");
$result = $database->query("SELECT * FROM ".TABLE_PREFIX."mod_404 ORDER BY LENGTH(404_wrong) desc"); 
if ($result && $result->numRows() > 0) {
	while($row = $result->fetchRow()){
		$wrong[$row['404_id']] = $row['404_right'].'|'.$row['404_wrong'].'|'.$row['404_link'];
	}
}
foreach ($wrong as $id => $value) { 
	$d = explode('|',$value);
	if ($d[2] && stripos($url,$d[1]) !== false) {
		$link = $d[2];
		if(_404_short_used()) {
			$page_link = WB_URL.$link.'/';
		} else {
			$page_link = $wb->page_link($link);
		}
		break;
	} elseif ($d[0] && stripos($url,$d[1]) !== false) {
		$link = $database->get_one("SELECT link FROM ".TABLE_PREFIX."pages WHERE `page_id` = '".$d[0]."'");
		if(_404_short_used()) {
			$page_link = WB_URL.$link.'/';
		} else {
			$page_link = $wb->page_link($link);
		}
		break;
	}
}

_404_log($url, $page_link);

if($page_link) die(header('Location: '.$page_link , TRUE , 301));
		
?>