<?php
/**
 *
 * @category        modules
 * @package         404 page redirect
 * @author          Ruud Eisinga / Dev4me
 * @link			http://www.dev4me.nl/modules-snippets/opensource/404/
 * @license         http://www.gnu.org/licenses/gpl.html
 * @platform        WebsiteBaker 2.8.x
 * @requirements    PHP 5.6 and higher
 * @version         1.5.0
 * @lastmodified    June 21, 2020
 *
 *
 */

 // define seperators for internal arrays
define('SEP1',chr(7));
define('SEP2',chr(8));
define('SEP3',chr(9));
define('SEP4',chr(11));

$MOD_404 = array(
	'TXT_TITLE'		=> '404 - Redirect',
	'TXT_LEGEND'	=> 'Create a .htaccessfile in the webroot and add the following line to that file',
	'TXT_SHORTPHP'	=> 'You seem to be using "shorturl". Change the "ERROR_PAGE" definition in {WEBSITE_ROOT}/short.php to:',
	'TXT_WBPHP'		=> 'You seem to be using "shorturl". Change the "ERROR_PAGE" definition in {WEBSITE_ROOT}/wb.php to:',
	'TXT_HELP'		=> 'Help',
	'TXT_CONFIG'	=> 'Config',
	'TXT_RULES'		=> 'Rules',
	'TXT_HISTORY'	=> 'History',
	'TXT_ERRORURL'	=> 'Error url (partly) - Blank to remove',
	'TXT_REDIRPAGE'	=> 'Redirect Page',
	'TXT_SAVE'		=> 'Save',
	'TXT_UPDATE'	=> 'Update this',
	'TXT_ADDNEW'	=> 'Add new',
	'TXT_NEW'		=> 'New entry',
	'TXT_SELECT'	=> '-- Select a page --',
	'TXT_CONFIG'	=> 'Configuration',
	'TXT_EMAIL'		=> 'Email address for notifications of wrong requests (leave empty for no email reporting)',
	'TXT_EMAILSUB'	=> 'Subject of the email',
	'TXT_SUBJECT'	=> 'Page not found on incoming request',
	'TXT_TIMESTAMP'	=> 'Date &amp; Time',
	'TXT_WEBSITE'	=> 'Website',
	'TXT_COUNTER'	=> 'Counter of last 14 days',
	'TXT_WRONGPAGE'	=> 'Wrong page requested',
	'TXT_REFERER'	=> 'Referer',
	'TXT_REMOTEIP'	=> 'Remote IP address',
	'TXT_REMOTEHOST'=> 'Remote hostname',
	'TXT_BROWSER'	=> 'Browser information',
	'TXT_BROWSERP'	=> 'Platform',
	'TXT_BROWSERV'	=> 'Version',
	'TXT_HIST_DATE'	=> 'Date',
	'TXT_HIST_TIME'	=> 'Time',
	'TXT_HIST_URL'	=> 'Url',
	'TXT_HIST_REF'	=> 'Referer',
	'TXT_STOREIP'	=> 'Store visitor IP address/hostname',
	'TXT_INTERVAL'	=> 'Send emails once per',
	'TXT_INTHELP'	=> 'An email with all errors is sent on the next error after the number of hours set here',
	'TXT_INT0'		=> 'Every error',
	'TXT_INT3'		=> '3 hours',
	'TXT_INT6'		=> '6 hours',
	'TXT_INT12'		=> '12 hours',
	'TXT_INT24'		=> '24 hours',
	'TXT_YES'		=> 'Yes',
	'TXT_NO'		=> 'No',
	'TXT_WITHREF'	=> 'Report only entries with referrer',
	'TXT_BAKERY'	=> 'Include bakery pages in redirects',
	'TXT_OFA'		=> 'Include oneforall pages in redirects',
);

?>